/*  ------------------------------------------------------------------------------

	   Purupose: To display both the Store-Record and Sale-Records on the 
	             Screen at the same time.
	   
	   
	     Author: Bruce Martin

	------------------------------------------------------------------------------ */
		
	var line = null;
	var store = null;
	
	getLineAndStore();
 
  	if (line === null) {
  		RecordEditorData.showMessage("Store " + store + " was not found");
  	} else {		
		var dtar020_Data = findSalesFile();
		
		if (dtar020_Data == null) {
			RecordEditorData.showMessage("Sales file is not available");
		} else {
			showScreens()
		}
  	}

/*
        Retrieve the Line & Store details          
*/
function getLineAndStore() {
	var recNum = RecordEditorData.currentRecordNumber;

	if (recNum < 0) {
		var str = parseInt(RecordEditorData.ask("What Store number ??"));
		if (str < 5000) {
			str = str + 5000;
		}
		store = str;
		for (j = 0; j < RecordEditorData.view.getRowCount(); j++) {
			if (RecordEditorData.view.getLine(j).getFieldValue("Loc Nbr").asInt() == store) {
				line = RecordEditorData.view.getLine(j);
			}
		}
	} else {
		line = RecordEditorData.view.getLine(recNum);
		store = line.getFieldValue("Loc Nbr").asInt();
	}
}
  
/*
      Search the files being edited for the Sales file and return it
*/
function findSalesFile() {

	var fileBeingEdited = RecordEditorData.getFileList();	         
	for (i = 0; i < fileBeingEdited.size(); i++) {
		var fd = fileBeingEdited.get(i);                  
		if (fd.layout.getLayoutName() == "DTAR020") {
			return fd.getScriptData();
		}
	}
	var dir = RecordEditorData.getDirectoryName();
	if (dir != null) {
		var salesFileScreen = RecordEditorData.openFile(dir + "DTAR020.bin", "DTAR020");
		if (salesFileScreen != null) {
			return RecordEditorData.newScriptData(salesFileScreen);	
		}
	}
	
	return null;
}

/*
    Create Store based screens from the 2 files.
*/
function showScreens() {
	var storeDtls = RecordEditorData.getNewLineList();
	var storeSales = dtar020_Data.getNewLineList();

	storeDtls.add(line);
	
	store = store - 5000;
	
	for (j = 0; j < dtar020_Data.view.getRowCount(); j++) {
		if (dtar020_Data.view.getLine(j).getFieldValue("STORE-NO").asInt() == store) {
			storeSales.add(dtar020_Data.view.getLine(j));
		}
	}
	if (storeSales.size() > 0) {
		var listType = RecordEditorData.displayConstants.ST_LIST_SCREEN;
		var recType = RecordEditorData.displayConstants.ST_RECORD_SCREEN;
		var screen1 = RecordEditorData.displayList(recType, "Store: " + store, storeDtls);
		var screen2 = dtar020_Data.displayList(listType, "Sales: " + store, storeSales);
		                                        
		screen1.unDock();
		screen2.unDock();
		screen1.parentFrame.setBounds(0, 0, 600, 500); 
		screen2.parentFrame.setBounds(601, 0, 1300, 600); 
		screen1.parentFrame.moveToFront();
		screen2.parentFrame.moveToFront();
	} else {
		print("No sales");
	}	
}
	